/****************************************
** Program: Oszacowanie Monte Carlo
** Autor: Marek Ha
** Data: 29.05.2006
** Wersja dla Windows95/98/ME/XP
****************************************/

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

long double suma;

void __fastcall TForm1::button_startClick(TObject *Sender)
{
AnsiString pom,pom2,mnoznik;
 int pozycja;
    numer = 0;
     suma = 0;

   ListBox1->Clear();

   randomize();

     for (int i=0; i<20; i++)
      {
        numer++;
        monte_carlo(suwak->Position);
      }

   pom = FloatToStrF((suma/20),ffFixed,12,4);
   pozycja = pom.Pos("E");

      if (pozycja==0)
        edit_srednia->Text = FloatToStrF((suma/20),ffFixed,12,0);
      else
         {
           mnoznik = pom;
           mnoznik.Delete(1,pozycja);

           pom.Delete(pozycja,pom.Length());
           edit_srednia->Text = pom + " * (10^" + mnoznik + ")";
         }

      suwak->Enabled = true;
      edit_srednia->Color = clMoneyGreen;

}
//---------------------------------------------------------------------------

void TForm1::monte_carlo(int n)
{
  AnsiString s;
  int i, j,m;
  long double mprod, numnodes;
  Set <int, 1, 101> prom_children;

  i = 0;
  numnodes = 1;
  m = 1;
  mprod = 1;

  while (m != 0 && i != n)
   {
     mprod = mprod * m;
     numnodes = numnodes + mprod * n;

     i++;
     m = 0;
     prom_children.Clear();
     for (j = 1; j <= n; j++)
       {
            col[i] = j;
            if (czy_Obiecujacy (i))
               {
                m++;
                prom_children<<j;
               }
        }
     if (m != 0){

           do

             j = random(n+1);

           while (prom_children.Contains(j) == false);
          col [i] = j;
        }
   }


   s = FloatToStrF(numnodes,ffFixed,14,4);

   ListBox1->Items->Add(IntToStr(numer) + ") " + FloatToStrF(numnodes,ffFixed,12,0));
   suma=suma+numnodes;
}

bool TForm1::czy_Obiecujacy(int i)
{
  int k;
  bool obiecujacy;
  k = 1;
  obiecujacy = true;

  while (k<i && obiecujacy)
   {
     if (col[i] == col[k] || abs (col[i]-col[k])==i-k)
      obiecujacy = false;
     k++;
   }
 return obiecujacy;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::suwakChange(TObject *Sender)
{
  rozmiar->Caption = IntToStr(suwak->Position) + " x " + IntToStr(suwak->Position);
}
//---------------------------------------------------------------------------




